//specifying package wblut.hemesh allows access to protected members of HE_Mesh and other elements
package wblut.hemesh;
import wblut.geom.WB_Plane;
import wblut.geom.WB_Point;
//Modifier extends the abstract base class HEB_Modifier
public class HEM_Noise extends HEB_Modifier{

  private double amplitude;

  //Default modifier
  public HEM_Noise() {
    super();
  }

  //returning the HEM_Noise object "this" allows chaining of setParameter
  public HEM_Noise setAmplitude(double d){
    amplitude=d;
    return this;
  }


  //modify is called when the entire mesh is the target
  @Override
    protected HE_Mesh modify(HE_Mesh mesh) {
      float a=(float)amplitude;
      HE_Vertex v=mesh.firstVertex();
      for(int i=0;i<mesh.numberOfVertices();i++){
        
        //Processing functions need to be called from an instance of the PApplet class
        //This is usually the protected member _home of the modified mesh.			
        WB_Point n=new WB_Point(mesh._home.random(-a,a),mesh._home.random(-a,a),mesh._home.random(-a,a));
        v.add(n);
        v=mesh.nextVertex();
      }
      return mesh;
    }

  //modifySelected is called when a selection is the target
  @Override
    protected HE_Mesh modifySelected(HE_Mesh mesh, HE_Selection selection) {
    float a=(float)amplitude;
      //selection needs to be update to include all vertices of selected faces
      selection.collectVertices();
      HE_Vertex v=selection.firstVertex();
      for(int i=0;i<selection.numberOfVertices();i++){
        
        //Processing functions need to be called from an instance of the PApplet class
        //This is usually the protected member _home of the modified mesh.				
        WB_Point n=new WB_Point(mesh._home.random(-a,a),mesh._home.random(-a,a),mesh._home.random(-a,a));
        v.add(n);
        v=selection.nextVertex();
      }
      return mesh;
    }

}

